#!/usr/bin/tclsh

# --
# Copyright (C) 2000 by Dr. Franz-Josef Huecker
# w3: http://www.huecker.com ; email: info@huecker.com
# Script: hc_search.cgi !
#
# Required: tcl.lib, and glimpse !
# --

# --
# Begin of Setup !

set email charly@your-domain.com                             ;# e-mail address
set domain "your-domain.com"                                 ;# name of domain
set glimpse_path /usr/bin                                    ;# glimpse path
set gifs /gifs                                               ;# images path
set index_path /home/www/pub/your-domain.com/cgi-bin/index   ;# index path
set html_path /home/www/pub/your-domain.com                  ;# html path
set URL http://www.your-domain.com                           ;# URL
set homepage welcome.html                                    ;# name of homepage

# End of Setup !
# --

source tcl.lib

cgi_var status words modus errors ltm lf lfm

puts "Content-type: text/html"
puts {

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 //EN">
<!--Autor: Dr. Franz-Josef Huecker, Berlin/Germany, 01.00-->

<html>
 <head>
}

puts "<title>$domain > search</title>"

puts {
 </head>

<body bgcolor=#ffffff text=#000000 link=#000080 vlink=#800080>

}

if {$status=="search"} {

if {$words==""} {

puts "<font size=2 face=\"Verdana, Arial\">search field is empty</font>"

} elseif ![file exists $glimpse_path/glimpse] {

puts "<font size=2 face=\"Verdana, Arial\">glimpse not found</font>"

} else {

if {$modus=="on"} {
set modus w
} else {
set modus i
}

catch {

set container [exec $glimpse_path/glimpse -U -W -$errors -L $ltm:$lf:$lfm -y -c -$modus -H $index_path "$words"]

}

if ![info exists container] {

puts "<font size=2 face=\"Verdana, Arial\">glimpse encountered an error</font>"

}

if {$container==""} {

puts "<font size=2 face=\"Verdana, Arial\"><strong>$words</strong> not found</font>"

} else {

# --

regsub -all $html_path $container "# $html_path" container
set container [split $container #]
regsub "{}" $container "" container
set records [llength $container]

set a 0

while {$a <= [expr $records-1]} {

	set x [lindex $container $a]
	set hit [lindex $x end]
	set file [lindex $x 0]
	regsub $html_path/ $file {} file
	set file $URL/$file
	set title [lrange $x 1 [expr [llength $x]-2]]
	set title [string trimright $title :]

	if {$title=="No Title"} {
	   set title "title not found"
	}

	incr a

# --

lappend lx "$hit $file $title"

}

catch {
set lx [lsort -decreasing -dictionary $lx]
}

puts {
<center><table bgcolor=#ffffff width=95% border=0 cellpadding=10 cellspacing=0>
<tr><td width=20% align=left valign=top>
}

puts "<br><br><br><br><br><a href=\"hc_search.cgi\"><img src=\"$gifs/hc_search.jpg\" border=0 alt=\"search $domain\"></a>"

puts "</td><td width=80% align=left valign=bottom>
<font size=2 face=\"Verdana, Arial\"><br><br>Results for : &#160;<strong>$words</strong></font>
<br><hr size=1 width=52% align=left>"

puts "<center><br><table width=100% border=0 cellpadding=4 cellspacing=0>
<tr><td width=12% align=right valign=bottom><font size=1 face=\"Verdana, Arial\">matches</font></td><td width=88% align=left valign=bottom><font size=1 face=\"Verdana, Arial\">file</font></td></tr>"

foreach el $lx {
  set hit   [lindex $el 0]
  set file  [lindex $el 1]
  set title [lrange $el 2 end]
  
puts "<tr><td width=12% align=right valign=bottom><font size=2 face=\"Verdana, Arial\">$hit</font></td><td width=88% align=left valign=bottom><font size=2 face=\"Verdana, Arial\"><a href=\"$file\">$title</a></font></td></tr>"

}

puts "</table></center>"

puts "<p>--<br><a href=\"hc_search.cgi\">new search</a> | <a href=\"/$homepage\">home</a>"

puts {
<p><hr size=1 width=52% align=left>
<font size="1" face="Verdana, Arial">&copy; 2000 Franz-Josef H&uuml;cker. All Rights Reserved.</font>

</td></tr>
</table></center>
}

# --

  }
 }

puts {
</td></tr>
</table>
}

} elseif {$status=="help"} {

puts {

<center>
<table bgcolor=#ffffff width=95% border=0 cellpadding=10 cellspacing=0>
<tr><td width=20% align=left valign=top>

}

puts "<br><br><br><a href=\"hc_search.cgi\"><img src=\"$gifs/hc_search.jpg\" border=0 alt=\"search $domain\"></a>"

puts {

</td><td width=80% align=left valign=bottom>

<font size=2 face="Verdana, Arial" color=#000080><strong><br><br>Nutzung der Suchfunktion</strong></font>

<br><hr size=1 width=52% align=left>

<font size=2 face="Verdana, Arial">
<p>Die Suchfunktion ermglicht dasselbe wie der Index eines Sachbuches: Hat das Programm den gesuchten Begriff oder Text gefunden, prsentiert es Links zu allen Seiten, auf denen der gesuchte Begriff oder Text vorhanden ist.

<p align=center>Je genauer die Eingabe, desto besser das Ergebnis!</center>

<p><b>1.</b> &#160; Gefunden werden <b>Begriffe</b> oder <b>Stze</b>, die in das Textfeld in der richtigen Schreibweise eingegeben wurden und auf den HTML-Seiten vorhanden sind. Mglich ist auch die fragmentierte Suche, also die unvollstndige Eingabe des Suchbegriffs oder Textes. 

<p><b>Beispiele</b>
<ul>
	<p>Eingabe: NLP
	<br>* Ergebnis: alle Seiten, auf denen der Begriff NLP steht.
		
	<p>Eingabe: Neuro-Linguistisches
	<br>* Ergebnis: alle Seiten, auf denen diese Wrter stehen.

	<p>Eingabe: Neuro-Linguistisches Programmieren
	<br>* Ergebnis: alle Seiten, auf denen dieser Begriff steht.

	<p>Eingabe: Was ist Neuro-Linguistisches Programmieren?
	<br>* Ergebnis: alle Seiten, auf denen dieser Satz steht.
</ul>

<p><b>2.</b> &#160; Die Zeichen <strong>Semikolon</strong> (= und) und <strong>Komma</strong> (= oder) ermglichen die <b>eingeschrnkte</b> und die <b>erweiterte Suche</b>. Verwenden Sie diese Optionen, mssen Sie Leerstellen zwischen den Suchbegriffen vermeiden.

<p><b>Beispiele</b>

<ul>
	<p>Eingabe: Bandler;Dilts
	<br>* Ergebnis: alle Seiten, auf denen Bandler <u>und</u> Dilts stehen.

	<p>Eingabe: Bandler,Dilts
	<br>* Ergebnis: alle Seiten auf denen Bandler <u>oder</u> Dilts steht.
</ul>

<p><b>3.</b> &#160; Auf die Unterscheidung von <b>Gro- und Kleinschreibung</b> bei der Eingabe kann verzichtet werden - die Suche nach "bandler;dilts" fhrt mithin zu dem gleichen Ergebnis wie die Suche nach "Bandler;Dilts".

<p><b>4.</b> &#160;  <b>Dynamische HTML-Seiten</b> werden nicht indexiert, knnen mit diesem Programm also auch nicht gefunden werden.

}

puts "<p><br>Falls Sie Fragen haben oder Suchoptionen entdecken, die hier auch dokumentiert werden sollten, senden Sie uns bitte eine <a href=\"mailto:$email\">e-mail</a>. Und nun: <b><a href=\"hc_search.cgi\">search now</a></b> !</font>"

puts {

<p><hr size=1 width=52% align=left>
<font size="1" face="Verdana, Arial">&copy; 2000 Franz-Josef H&uuml;cker. All Rights Reserved.</font>

</td></tr>
</table>
</center>

 </body>
</html>

 }
} else {

puts {

<center>
<p><br><br><br><br><table bgcolor=#ffffff width=95% border=0 cellpadding=10 cellspacing=0>
<tr><td width=20% align=left valign=middle>

}

puts "<a href=\"/$homepage\"><img src=\"$gifs/hc_search.jpg\" border=0 alt=\"search $domain\"></a>
</td><td width=80% align=left valign=bottom>
<font size=2 face=\"Verdana, Arial\" color=#000080><strong>$domain</strong></font>
<br><hr size=1 width=52% align=left>"

puts {
<p><form method="post" action="hc_search.cgi">
<font size=2 face="Verdana, Arial">
<input type="hidden" name="status" value="search">
<input type="submit" value="Search"></font>  &#160; <input type=TEXT name="words" size=25 maxlength=40>
</font>

<p><font size=2 face="Verdana, Arial"><strong> &#160;  &#160;  &#160; Sensitive:</strong> <input type=RADIO name="modus" value="off" checked>off  <input type=RADIO name="modus" value="on">on   &#160; | <strong><a href="hc_search.cgi?status=help">help</a></strong>

<br><strong> &#160;  &#160; Misspellings</strong> allowed: 
<input type=RADIO name="errors" value="0" checked>0 
<input type=RADIO name="errors" value="1">1 
<input type=RADIO name="errors" value="2">2 

<p><font size=2 face="Verdana, Arial"><strong> &#160;  Limits</strong> 

 &#160; matches <select name="ltm">
	<option value=0>
	<option>1
	<option>5
	<option>10
	<option>15
	<option selected>20
	<option>25
	<option>30
	<option>40
	<option>50
 </select>

<br>&#160; &#160; files <select name="lf">
	<option value=0 selected>
	<option>1
	<option>5
	<option>10
	<option>15
	<option>20
	<option>25
	<option>30
	<option>40
	<option>50
 </select>

 &#160; matches of files <select name="lfm">
	<option value=0 selected>
	<option>1
	<option>5
	<option>10
	<option>15
	<option>20
	<option>25
	<option>30
	<option>40
	<option>50
 </select>

 </form>
</font>

<p><hr size=1 width=52% align=left>
<font size="1" face="Verdana, Arial">&copy; 2000 Franz-Josef H&uuml;cker. All Rights Reserved.</font>

</td></tr>
</table>
</center>

 </body>
</html>

 }
}